require 'settings'
require 'controllers/controller'
require 'controllers/menu_controller'
require 'controllers/levelselection_menu_controller'
require 'controllers/editor_controller'
require 'player'
require 'fadeover_effects/crossfade_effect'

class MainMenuController < MenuController
  def initialize
    super
    
    @menu_items = [{
      :title     => "Local Game",
      :on_select => lambda { finish! LevelselectionMenuController.new }
    },
    {
      :title     => "Network Game",
      :on_select => lambda {  }
    },
    {
      :title     => "Settings",
      :on_select => lambda {  }
    },
    {
      :title     => "Leveleditor",
      :on_select => lambda {  }
    },
    {
      :title     => "Exit",
      :on_select => lambda { finish! }
    }]
  end
  
  def handle_event(event)
    finish! if @keys.include?(:escape)
    super
  end
  
  def draw(srf)
    srf.fill [50, 50, 0]
    super
  end
  
  def finish!(next_controller = nil)
    super next_controller, CrossfadeEffect.new
  end
end
