require 'vector'
require 'sprite'

class GameObject
  attr_accessor :pos, :sprite
  
  def initialize(position, sprite)
    @sprite = sprite
    @pos    = V(position)
  end
  
  def draw(srf, offset = nil)
    @sprite.draw srf, @pos + offset
  end
  
  def update(dtime)
    @sprite.update(dtime) unless @sprite.nil?
  end
end
