require 'items/item'
require 'items/bomb_item'
require 'items/speed_item'
require 'items/explosive_force_item'
require 'items/life_item'
require 'items/snail_item'

class BlowableWall < Item
  def initialize(field)
    super field, Sprite.new("blowable_wall.png")
    
    @contained_items = []
    unless Level.currently_loading.nil?
      propability  = Level.currently_loading["items"]["propability"]
      distribution = Level.currently_loading["items"]["distribution"]
      if rand < propability
        @contained_items.push(distribution[rand(distribution.size)].new(field))
      end
    end
  end
  
  def walkable?
    false
  end
  def blowable?
    true
  end
  def blocks_explosion?
    true
  end
  
  def blown(explosion)
    @field.items -= [self]
    @field.items += @contained_items
  end
end
