class Settings
  def initialize(settings = nil)
    @settings = settings || Settings.defaults
  end
  
  def self.[](key)
    s = Settings.new
    s[key].class == Hash ? Settings.new(s[key]) : s[key]
  end
  def [](key)
    @settings[key].class == Hash ? Settings.new(@settings[key]) : @settings[key]
  end
  
  def self.method_missing(key)
    Settings[key]
  end
  def method_missing(key)
    self[key]
  end
  
  def get(key)
    @settings[key]
  end
  
  
  def self.defaults
    {
      :video => {
        :screen_size => [800, 600],
      },
      :audio => {
        :music_volume_menu => 1.0,
        :music_volume_game => 0.5,
      },
      :gameplay => {
        :bomb_time => 3000,
        :explosion_time => 500,
      
        :initial_explosive_force => 1,
        :initial_max_bombs => 1,
        :initial_lives => 3,
      
        :initial_speed => 0.10,
        :item_speed_increase => 0.025,
        :max_speed => 0.35,
      
        :sudden_death_after => 3*60*1000,
      
        :level_defaults => {
          "items" => {
            "propability" => 0.3,
            "distribution" => {
              "Bomb" => 10,
              "ExplosiveForce" => 10,
              "Life" => 2,
              "Speed" => 5,
              "Snail" => 0,
            },
          },
        },
      },
      :controls => [
        {
          :up    => :up,
          :down  => :down,
          :left  => :left,
          :right => :right,
          :plant_bomb => :period,
          :secondary_weapon => :comma,
        },
        {
          :up    => :i,
          :down  => :k,
          :left  => :j,
          :right => :l,
          :plant_bomb => :space,
          :secondary_weapon => :m,
        },
        {
          :up    => :t,
          :down  => :g,
          :left  => :f,
          :right => :h,
          :plant_bomb => :x,
          :secondary_weapon => :y,
        },
        {
          :up    => :w,
          :down  => :s,
          :left  => :a,
          :right => :d,
          :plant_bomb => :left_shift,
          :secondary_weapon => :caps_lock,
        },
      ],
    }
  end
end
