class Timer
  attr_accessor :times, :name
  
  @@clock = nil
  def self.setup
    @@clock = Rubygame::Clock.new
    @@clock.calibrate
  end
  
  def initialize(name)
    @name = name
    @times = []
  end
  
  def start
    @start_time = @@clock.lifetime
  end
  
  def stop
    @times += [@@clock.lifetime - @start_time]
  end
  
  def average_time
    @times.inject{ |sum, el| sum + el }.to_f / @times.size
  end
  
  
  @@timers = {}
  def self.[](i)
    @@timers[i] ||= Timer.new(i.to_s)
  end
  
  def self.print_all
    @@timers.each do |key, val|
      puts key
      puts val.average_time
      puts ""
    end
  end
end
